// renames the updateList function, hidding the spells in the new version
updateListOriginal = updateList
updateList = function updateList(listName, listData) {
	updateListOriginal(listName, listData);
	if (listName="inventory")
		$('#lstInventory li:contains("--")').css('display','none');
};

function scrollToEnd() {
    var scrollTo = _animateScroll ? beginningOfCurrentTurnScrollPosition - 50 - $("#gamePanelSpacer").height() : $(document).height();
    var currentScrollTop = Math.max($("body").scrollTop(), $("html").scrollTop());
    if (scrollTo > currentScrollTop) {
        var maxScrollTop = $(document).height() - $(window).height();
        if (scrollTo > maxScrollTop) scrollTo = maxScrollTop;
        var distance = scrollTo - currentScrollTop;
        var duration = _animateScroll ? distance / 0.4 : 1;
		if (duration>2000)
			duration=2000
        $("body,html").stop().animate({ scrollTop: scrollTo }, duration, "easeInOutCubic");
    }
    $("#txtCommand").focus();
}
function executeJS(str) {
	args = str.split(";");
	alert("executeJS received "+args);
	window[executeFunctionByName].apply(window, args);
}

function executeFunctionByName(functionName) {//,context
  var args = [].slice.call(arguments).splice(1);//2
  var context = window;
  var namespaces = functionName.split(".");
  var func = namespaces.pop();
  for(var i = 0; i < namespaces.length; i++) {
    context = context[namespaces[i]];
  }
  return context[func].apply(context, args);
}
function startVourtram() {
	
	var ret = "web:"+webPlayer;
	ASLTimed("start_callback",ret);
}
function ASLTimed() {
	var args = arguments;	
	window.setTimeout(function () {  //f.apply(f, ['hello', ' ', 'world']));
	   if (canSendCommand) {
			//ASLEvent(x,y)
			ASLEvent.apply(ASLEvent,args);
	   } else {
			//ASLTimed(x,y)
			ASLTimed.apply(ASLTimed,args);
	   }
    }, 50);
}
function getLoadData() {
	var saves = getSaveGames()
	var data="";
	
	for (var key in saves) {
		if (saves.hasOwnProperty(key)) {
			if (data!=="") {
				data=data+"|";
			}				
			data=data+key+":"+saves[key];
		}
	}	
	return data;
}
function decodeLoadData(data) {
    var saves = data.split("|");
	var ret ={};
	for (var i=0;i<saves.length;i++) {
		info = saves[i].split(":");
		ret[info[0]] = info[1];
		//ret[i] = {name:info[0],data:info[1]};
	}
	return ret;	
}
function loadLocal() {
	var data = getLoadData();
	//var cmds = JSON.parse(data);
	ASLTimed("js_loadgame",data);	
}
function retrieveSaves() {
	var data = getLoadData();
	//var cmds = JSON.parse(data);
	ASLTimed("js_retrieveSaves",data);	
}
function saveLocal(name,data) {
	/*
	var cmdList = $('#loadData');
	if (cmdList.length==0) {
	   $('#gamePanes').append('<div id="loadData"></div>');
	   cmdList = $('#loadData');
	}
	cmdList.html(data);*/
	
	var saves = getSaveGames();
	if (saves==null)
		saves={};
	saves[name]=data;
	//saves.push({name:name,data:data});
	setSaveGames(saves);
	
}
var store={};
function getSaveGames() {
	var saves = getStorage(SAVE_CODE);
	if (webPlayer) {	
		saves=JSON.parse(saves);
	}
	return saves;
}
function setSaveGames(saves) {
	if (webPlayer) {
		saves = JSON.stringify(saves); 
	}
	setStorage(SAVE_CODE,saves);
}
function getStorage(name) {
    if (webPlayer) {	
		if (typeof(Storage) !== "undefined") {
		    var str = localStorage.getItem(name);
			return str;
		} else {
			return null;
		}
	} else {
		return store[name];
	}
}
function setStorage(name,value) {
	if (webPlayer) {		
		if (typeof(Storage) !== "undefined") {
			localStorage.setItem(name, value);
		}
	} else {
		store[name]=value;
		return;
	}
}
function chooseLoadGame(game,data) {
	setStorage("LoadGame",game);
	var saves = decodeLoadData(data);
	setSaveGames(saves);
	if (webPlayer)
		window.location=NEW_GAME_URL;
	
}
function restartLoading() {
	var load = getStorage("LoadGame");
	if (load!=null && load!="") {
		var data = getLoadData();
		setStorage("LoadGame","");
		ASLTimed("js_loadgame",data+"#"+load);
	}
}




/*
function queueCommand(cmds) {
window.setTimeout(function () {
       if (cmds.length>0) {
		   if (canSendCommand) {
				//send....
				var cmd = cmds[0]
				if (typeof cmd=="string") {
					ASLEvent('ShowMenuResponse',cmd);
				} else {
					var cn = cmd.command.toLowerCase().trim();		
					
					if (cn.lastIndexOf("load", 0) !== 0 && cn.lastIndexOf("save", 0) !== 0) {				
						sendCommand(cmd.command,cmd.metadata)
					}
				}
				//
				cmds.splice(0, 1);
			}
			queueCommand(cmds)		   
		}
    }, 20);
}
*/
music_links=[
	"https://www.youtube.com/embed/DEeAN471boQ?rel=0&autoplay=1&loop=1&playlist=DEeAN471boQ",
	"https://www.youtube.com/embed/YnziQL2FUQs?rel=0&autoplay=1&loop=0&playlist=DEeAN471boQ",
	"https://www.youtube.com/embed/N-tCTMfVmfA?rel=0&autoplay=1&loop=1&playlist=N-tCTMfVmfA",
	"https://www.youtube.com/embed/VlYfxV40x4o?rel=0&autoplay=1&loop=1&playlist=N-tCTMfVmfA"];
music_num=0;
music_on=true;
music_titles=["Medieval music","Pavane","Middle ages Keyboard Instruments","Celtic Battle Music - Boudicca"];

function setTurnLabel(turn) {
    if ($('#music').length==0) {//gamePanesRunning		
		var music = $('#controlButtons').append('<div id="music"></div>');
		var onoff = music_on ? "on" : "off";
		$('#music').css("float","right").css("padding-left","8px").append('<a id="music_toggle">[music '+onoff+']</a>');
		$('#music_toggle').click(function() {
			toggleMusic();
		});
		
		if (music_on)
			toggleMusic();
		$( "#music" ).hover( 
			function() {
				if (music_on) {
					$( "#music_f" ).css("display","block");
					$('#music_toggle').text("[music on:"+music_titles[music_num]+"]");
				}
			}, 
			function() {
				if (music_on) {
					$( "#music_f" ).css("display","none");
					$('#music_toggle').text("[music on]");
				}
			} );
		
		$( "#music" ).bind('touchstart', 
			function() {
				if (music_on) {
					$( "#music_f" ).css("display","block");
					$('#music_toggle').text("[music on:"+music_titles[music_num]+"]");
				}
			});
		$( "#music" ).bind('touchend', 	
			function() {
				if (music_on) {
					$( "#music_f" ).css("display","none");
					$('#music_toggle').text("[music on]");
				}
			} );
		
	}
	if ($('#turn').length==0) {
		$('#cmdSave').css("display","none");
		$('#controlButtons').append('<b id=\"turn\">Turn: '+turn+'</b>');
		$("#turn").css("float","right");
	} else {
		$('#turn').text('Turn: '+turn);
	}
}

	
function playMusic(num) {
    var hasFrame = $('#music_f').length!=0;
	if (music_num==num && hasFrame) {
		return;
	}
	if (hasFrame) {
		$('#music_f').remove();
	}
	music_num=num;
	if (music_on) {
		$("#music").append('<iframe id="music_f" width="200" height="200" src="'+music_links[music_num]+'" frameborder="0" allowfullscreen></iframe>');
		$('#music_f').css("display","none");
		
	}
}
function checkMusic() {
	var smusic = getStorage("music");
	if (smusic=="off") {
		music_on=false;
	}
}


function toggleMusic() {
	if ($('#music_f').length==0) {	
		music_on=true;
		playMusic(music_num);
		$('#music_toggle').text("[music on]");
		setStorage("music","on");
	} else {
		$('#music_f').remove();
		$('#music_toggle').text("[music off]");
		setStorage("music","off");
		music_on=false;
	}
}


// Instrumental: https://www.youtube.com/watch?v=N-tCTMfVmfA
// Pavane: https://www.youtube.com/watch?v=YnziQL2FUQs ou <iframe width="560" height="315" src="https://www.youtube.com/embed/YnziQL2FUQs" frameborder="0" allowfullscreen></iframe>
/*

<iframe width=”300″ height=”24″ src="https://www.youtube.com/embed/DEeAN471boQ?rel=0&autohide=0&#8243" frameborder="0" allowfullscreen></iframe>
*/